<template>
    <section>
        <div class="container-quiz">
            <div class="quiz-header">
                <h1>Quiz</h1>
            </div>
            <div class="quiz-main" v-for="(element, index) in questions.slice(a,b)" :key="index" v-show="quiz">
                <div class="box-quesiton">
                    <h2>Question {{b}}/{{questions.length}}</h2>
                    <p>{{element.question}}</p>
                </div>
                <div class="box-suggestions">
                    <ul>
                        <li v-for="(item, index) in element.suggestions" :key="index" :class="correct ? check(item) : ''" @click="selectResponse(item, index)">{{item.suggestion}}</li>
                    </ul>
                </div>
            </div>
            <div class="box-score" v-if="score_show">
                <h2>Your score is</h2>
                <h2>{{score}}/{{questions.length}}</h2>
                <div class="btn-restart">
                    <button @click="restartQuiz">Restart<i class="fas fa-sync-alt"></i></button>
                </div>
            </div>    
            <div class="quiz-footer">
                <div v-if="progress < 100" class="box-button">
                    <button @click="skipQuestion()">Skip</button>
                    <button @click="nextQuestion()">Next</button>
                </div>
            </div>
        </div>
    </section>
</template>

<script>
export default {
    name: 'Questions',
    data(){
        return{
            questions: [
                {
                    question:'What’s the shortcut for the “copy” function on most computers?',
                    suggestions:[
                        {suggestion:'ctrl c', correct:true},
                        {suggestion:'ctrl v'},
                        {suggestion:'ctrl f'},
                    ]
                },
                {
                    question:'What part of the atom has no electric charge?',
                    suggestions:[
                        {suggestion:'Electron'},
                        {suggestion:'Proton'},
                        {suggestion:'Neutron', correct:true},
                    ]
                },
                {
                    question:'What is meteorology the study of?',
                    suggestions:[
                        {suggestion:'The space'},
                        {suggestion:'The meteors'},
                        {suggestion:'The weather', correct:true},
                    ]
                },
                {
                    question:'Which planet is the hottest in the solar system?',
                    suggestions:[
                        {suggestion:'Venus'},
                        {suggestion:'Mars'},
                        {suggestion:'Mercury', correct:true},
                    ]
                },
                {
                    question:'What is your body’s largest organ?',
                    suggestions:[
                        {suggestion:'The stomach'},
                        {suggestion:'The skin', correct:true},
                        {suggestion:'The lungs'},
                    ]
                },
            ],
            a:0,
            b:1,
            next:true,
            score_show:false,
            quiz:true,
            score:0,
            correct:false,
            progress:0,
        }
    },
    methods: {
    selectResponse(e){
        this.correct = true;
        this.next = false;
        if (e.correct) {
            this.score++;
        }
    },
    check(status){
        if(status.correct) {
            return 'correct'
        }else{
            return 'incorrect'
        }
    },
    nextQuestion(){
      if (this.next) {
        return;
      }
      this.progress = this.progress + (100/this.questions.length);
      if(this.questions.length - 1 == this.a){
        this.score_show = true;
        this.quiz = false;    
      }
      else{
        this.a++;
        this.b++;
        this.correct = false;
        this.next = true;
      }
    },
    skipQuestion(){
      if (!this.next) {
        return;
      }
      this.progress = this.progress + (100/this.questions.length);
      if(this.questions.length - 1 == this.a){
        this.score_show = true;
        this.quiz = false;
      }else{
        this.a++;
        this.b++;
      }
    },
    restartQuiz(){
      Object.assign(this.$data, this.$options.data()); // reset data in vue
    },
    }
}
</script>

<style scoped>
    .quiz-header {
        background-color:#81c784;
    }
    .quiz-footer {
        display: flex;
        width: 100%;
        justify-content: center;
        margin: auto;
    }
    .box-suggestions {
        display: flex;
        width: 100%;
        justify-content: center;
        margin: auto;
    }
    .box-button {
        display: flex;
        width: 100%;
    }
    .box-button button {
        width: 150px;
        height: 35px;
        outline: none;
        border: 0;
        color: white;
        font-size: 18px;
        cursor: pointer;
        border-radius: 15px;
        margin: auto;
        background-color:#81c784;
    }
    ul {
        display: flex;
        width: 80%;
        margin: 0;
        padding:0;
        flex-flow: column;
    }
    li {
        list-style: none;
        line-height: 2;
        border: 1px solid #81c784;
        margin-bottom: 20px;
        border-radius: 15px;
        cursor: pointer;
    }
    li:hover {
        background-color: #81c784;
    }
    li.correct {
        border: 1px solid rgb(74, 219, 74);
        background-color: rgb(74, 219, 74);
        color: white;
        font-weight: 600;
    }
    li.incorrect {
        border: 1px solid rgb(240, 117, 100);
        background-color: rgb(240, 117, 100);
        color: white;
        font-weight: 600;
    }
    .btn-restart {
        display: flex;
        justify-content: center;
        width: 150px;
        height: 35px;
        outline: none;
        border: 0;
        color: white;
        font-size: 18px;
        cursor: pointer;
        border-radius: 15px;
        margin: auto;
        background-color:#81c784;
    }
</style>